import {Command} from 'ckeditor5/src/core';
import {  getClosestSelectedSpanElement, checkCanBeSpan } from "./utils"; 
import { first } from 'ckeditor5/src/utils';


//import { DocumentFragment, Element, Position, Range, Schema, Writer } from 'ckeditor5/src/engine';

const SPAN = 'span';

export default class SpanCommand extends Command {
  constructor( editor, attributeKey ) {
		super( editor );

		this.attributeKey = attributeKey;
	}



  execute(settings) { 
    //console.log('execute addSpan', settings );
    const model = this.editor.model;
    const schema = model.schema;
    const selection = model.document.selection;
    const existingSpan = getClosestSelectedSpanElement(selection);
    

    if(!settings)
      settings = {};

    var content = settings.content ? settings.content : this.value +'<br>'+'ggg';
    var id = settings.id? settings.id :'';
    var className = settings.className? settings.className :'';
    var langcode = settings.langcode? settings.langcode :'';
    var rawStyles = settings.rawStyles? settings.rawStyles :'';
    var title = settings.title? settings.title :'';

    var attributes = { class: className, id: id, lang: langcode, style: rawStyles, title: title };

		//const value = ( settings.forceValue === undefined ) ? this.value : options.forceValue;

		//const blocks = Array.from( selection.getSelectedBlocks() );

      model.change((writer) => {

        if(existingSpan)
        {
          //console.log('existingSpan OK', existingSpan );
          writer.setAttributes(attributes, existingSpan);
        }
        else 
        {
          //console.log('existingSpan KO', existingSpan );
          
          //const docFrag = this.editor.model.change( writer => {
          //  const spanElt = writer.createElement( SPAN, attributes);
          //  const docFrag = writer.createDocumentFragment();
          //  writer.append( spanElt, docFrag );
          //  writer.insertText( content, spanElt ); 
          //  return docFrag;
          //} );
          //this.editor.model.insertContent( docFrag );

          
          //if(this.value) { console.log('mmmmmm', content, this.value)
            const spanElt = writer.createElement( SPAN, attributes);
            writer.wrap(  selection.getFirstRange(), spanElt );
          //}
        }

      });
  }




  refresh() {
    const block = first( this.editor.model.document.selection.getSelectedBlocks() );

		this.value = !!block && block.name == this.attributeKey;
		this.isEnabled = !!block && checkCanBeSpan( block, this.editor.model.schema );
    //console.log('refresh', 'value : *', this.value, '*enabled : ', this.isEnabled)
  }
}

