import {Command} from 'ckeditor5/src/core';
import {  getClosestSelectedSpanElement  } from "./utils"; 
//import { first } from 'ckeditor5/src/utils';


//import { DocumentFragment, Element, Position, Range, Schema, Writer } from 'ckeditor5/src/engine';

export default class SpanRemoveCommand extends Command {
  constructor( editor, attributeKey ) {
		super( editor );
		this.attributeKey = attributeKey;
	}

  execute(settings) {
    const model = this.editor.model;
    //const schema = model.schema;
    const selection = model.document.selection;
    const existingSpan = getClosestSelectedSpanElement(selection);
    
    //console.log('execute removeSpan', settings );
    
    if(!settings) settings = {}; 

    //const selectedElement = selection.getSelectedElement();   
      
    model.change((writer) => {

      if(existingSpan)
      { 
        //const startOffset = existingSpan.startOffset;
        const data = existingSpan.getChild(0).data;

        writer.remove(existingSpan);
        const currentAttributes = selection.getAttributes();
        const insertPosition = selection.focus;
    
        writer.insertText( data, currentAttributes, insertPosition );
      }
    });
  }

}

